/*
 *  ifsniff.c - loggy tar.gz archive instrument, addin 
 *  that checks for promiscuous devices in the local
 *  system, recoded all for the loggy-1.1a version
 *  more secure than the first sniffcheck.c for any problem
 *  or for bug reporting mail me at this email address: evil@mojodo.it
 *
 *  THIS INSTRUMENT HAS BEEN CODED FOR EDUCATIONAL PURPOSES ONLY
 *  coded by Evil from MOJODO 2003 PROJECT
 *  IM NOT RESPONSIBLE OF YOUR ACT, DONT ABUSE IT www.mojodo.it (C)
 *
 */

#include "includes/sniff.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>

main (int argc, char *argv[])
{
   int fd, intface, prom_dev = 0;
   struct ifreq buf[MAXDEVS];
   struct ifconf ifc;

	if ((fd = socket (AF_INET, SOCK_DGRAM, 0)) >= 0) {
	    ifc.ifc_len = sizeof buf;
	    ifc.ifc_buf = (caddr_t) buf;

	    if (!(ioctl (fd, SIOCGIFCONF, (char *) &ifc))) {
		intface = ifc.ifc_len / sizeof (struct ifreq);

		if (!intface) {
		    fprintf(stderr, "  + fatal error: no interfaces found.\n");
		    exit(0);
		}
		fprintf(stderr, "  - %d interfaces found:\n", intface);
		while (intface-- > 0) {
		    fprintf (stderr, "\t%s: ", buf[intface].ifr_name);
		    if (!(ioctl(fd, SIOCGIFFLAGS, (char *) &buf[intface]))) {
			if (buf[intface].ifr_flags & IFF_PROMISC) {
			    (void)fprintf (stderr, "promiscuous mode, possible running sniffer\n");
			    prom_dev++;
			} else {
			    fprintf (stderr, " no promiscuous\n");
			}
		    }
		    }
		}
    close(fd);
 }
    return prom_dev;
}
